<?php
/* --------------------------------------------------------------
   dependent.inc.php 2016-04-08
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2016 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   -------------------------------------------------------------- 
*/


// Add color column to order status table.
// =======================================

// Fetch current columns.
$orderStatusColumnsQuery = '
	SHOW
		COLUMNS
	FROM
		`orders_status`
';

// Execute query to get columns.
$orderStatusColumns = $this->query($orderStatusColumnsQuery);

// Flag to indicate if the `color` column has been found.
$foundColorColumn = false;

// Find `color` column.
foreach($orderStatusColumns as $column)
{
	if($column['Field'] === 'color')
	{
		$foundColorColumn = true;
		break;
	}
}

// Add missing column and entries.
if(!$foundColorColumn)
{
	// Add `color` column query.
	$addColumnQuery = '
		ALTER TABLE
			`orders_status`
		ADD
			`color` CHAR(6) NOT NULL DEFAULT "2196F3";
	';
	
	// Execute query.
	$this->query($addColumnQuery);
}

// Add house number column to address_book table.
// =================================================

// Check if `entry_house_number` column is in table address_book
$getColumns = $this->query("DESCRIBE `address_book` 'entry_house_number'", true);
if($getColumns->num_rows == 0)
{
	// Add `entry_house_number` column query.
	$addColumnQuery = 'ALTER TABLE `address_book` ADD `entry_house_number` VARCHAR(64) NOT NULL DEFAULT \'\' AFTER `entry_street_address`';
	$t_success &= $this->query($addColumnQuery);
}

$getColumns = $this->query("DESCRIBE `orders` 'order_total_weight'", true);
if($getColumns->num_rows == 0)
{
	$addColumnQuery = "ALTER TABLE `orders` ADD COLUMN `order_total_weight` DOUBLE PRECISION(11, 4) NULL AFTER `shipping_class`";
	$t_success &= $this->query($addColumnQuery);
}
// Add house number columns to orders table.
// =================================================

// Check if customer_house_number column is in orders table
$getColumns = $this->query("DESCRIBE `orders` 'customers_house_number'", true);
if($getColumns->num_rows == 0)
{
	// Add `entry_additional_info` column query.
	$addColumnQuery = 'ALTER TABLE `orders` ADD `customers_house_number` VARCHAR(64) NOT NULL DEFAULT \'\' AFTER `customers_street_address`';
	$t_success &= $this->query($addColumnQuery);
}

// Check if delivery_house_number column is in orders table
$getColumns = $this->query("DESCRIBE `orders` 'delivery_house_number'", true);
if($getColumns->num_rows == 0)
{
	// Add `entry_additional_info` column query.
	$addColumnQuery = 'ALTER TABLE `orders` ADD `delivery_house_number` VARCHAR(64) NOT NULL DEFAULT \'\' AFTER `delivery_street_address`';
	$t_success &= $this->query($addColumnQuery);
}

// Check if billing_house_number column is in orders table
$getColumns = $this->query("DESCRIBE `orders` 'billing_house_number'", true);
if($getColumns->num_rows == 0)
{
	// Add `entry_additional_info` column query.
	$addColumnQuery = 'ALTER TABLE `orders` ADD `billing_house_number` VARCHAR(64) NOT NULL DEFAULT \'\' AFTER `billing_street_address`';
	$t_success &= $this->query($addColumnQuery);
}

// Add additional info column to address_book table.
// =================================================

// Check if entry_additional_info column is in table address_book
$getColumns = $this->query("DESCRIBE `address_book` 'entry_additional_info'", true);
if($getColumns->num_rows == 0)
{
	// Add `entry_additional_info` column query.
	$addColumnQuery = 'ALTER TABLE `address_book` ADD `entry_additional_info` VARCHAR(255) NOT NULL DEFAULT \'\' AFTER `entry_house_number`';
	$t_success &= $this->query($addColumnQuery);
}

// Add additional info columns to orders table.
// =================================================

// Check if customers_additional_info column is in orders table
$getColumns = $this->query("DESCRIBE `orders` 'customers_additional_info'", true);
if($getColumns->num_rows == 0)
{
	// Add `entry_additional_info` column query.
	$addColumnQuery = 'ALTER TABLE `orders` ADD `customers_additional_info` VARCHAR(255) NOT NULL DEFAULT \'\' AFTER `customers_house_number`';
	$t_success &= $this->query($addColumnQuery);
}

// Check if delivery_additional_info column is in orders table
$getColumns = $this->query("DESCRIBE `orders` 'delivery_additional_info'", true);
if($getColumns->num_rows == 0)
{
	// Add `entry_additional_info` column query.
	$addColumnQuery = 'ALTER TABLE `orders` ADD `delivery_additional_info` VARCHAR(255) NOT NULL DEFAULT \'\' AFTER `delivery_house_number`';
	$t_success &= $this->query($addColumnQuery);
}

// Check if billing_additional_info column is in orders table
$getColumns = $this->query("DESCRIBE `orders` 'billing_additional_info'", true);
if($getColumns->num_rows == 0)
{
	// Add `entry_additional_info` column query.
	$addColumnQuery = 'ALTER TABLE `orders` ADD `billing_additional_info` VARCHAR(255) NOT NULL DEFAULT \'\' AFTER `billing_house_number`';
	$t_success &= $this->query($addColumnQuery);
}

// Add option value of additional info display to the configuration table.
// =======================================================================

// Query to get configuration entry.
$checkConfiguration = $this->query("SELECT * FROM `configuration` WHERE `configuration_key` = 'ACCOUNT_ADDITIONAL_INFO'",
                                   true);

// Create entry if not existent.
if($checkConfiguration->num_rows == 0)
{
	// Query to add entry.
	$addQuery = '
		INSERT INTO
			`configuration`
		SET
			`configuration_key` = "ACCOUNT_ADDITIONAL_INFO",
			`configuration_value` = "false",
			`configuration_group_id` = 5,
			`sort_order`= 5,
			`use_function` = NULL,
			`set_function` = "gm_cfg_select_option(array(\'true\', \'false\'),",
			`date_added` = NOW();
		';
	
	// Execute addition of configuration value query.
	$this->query($addQuery);
}

// START gm_laws admin access

$t_success &= $this->add_admin_access('gm_laws');

// END gm_laws admin access

// Add option value of additional info display to the configuration table.
// =======================================================================

// Query to get configuration entry.
$checkConfiguration = $this->query("SELECT * FROM `configuration` WHERE `configuration_key` = 'ACCOUNT_SPLIT_STREET_INFORMATION'",
                                   true);

// Create entry if not existent.
if($checkConfiguration->num_rows == 0)
{
	// Query to add entry.
	$addQuery = '
		INSERT INTO
			`configuration`
		SET
			`configuration_key` = "ACCOUNT_SPLIT_STREET_INFORMATION",
			`configuration_value` = "false",
			`configuration_group_id` = 5,
			`sort_order`= 5,
			`use_function` = NULL,
			`set_function` = "gm_cfg_select_option(array(\'true\', \'false\'),",
			`date_added` = NOW();
		';
	
	// Execute addition of configuration value query.
	$t_success &= (boolean)$this->query($addQuery);
}

// Tax calculation based on customer's VAT ID
// =================================================

$check = $this->query("SELECT * FROM `configuration` WHERE `configuration_key` = 'CALCULATE_TAX_BASED_ON_VAT_ID'", true);
if($check->num_rows == 0)
{
	$query = "INSERT INTO `configuration` SET `configuration_key` = 'CALCULATE_TAX_BASED_ON_VAT_ID', `configuration_value` = 'false', `configuration_group_id` = 18, `sort_order` = 8, `use_function` = NULL, `set_function` = 'gm_cfg_select_option(array(''true'', ''false''),', `date_added` = NOW()";
	$t_success &= (boolean)$this->query($query);
}

// Configuration values for cookie bar
// =================================================

$t_check = $this->query("SELECT * FROM `gm_configuration` WHERE `gm_key` = 'GM_COOKIE_STATUS'", true);
if($t_check->num_rows == 0)
{
	$t_query = "INSERT INTO `gm_configuration` (`gm_key`, `gm_value`) VALUES ('GM_COOKIE_STATUS', 'false')";
	$t_success &= $this->query($t_query, true);
}

$t_check = $this->query("SELECT * FROM `gm_configuration` WHERE `gm_key` = 'GM_COOKIE_POSITION'", true);
if($t_check->num_rows == 0)
{
	$t_query = "INSERT INTO `gm_configuration` (`gm_key`, `gm_value`) VALUES ('GM_COOKIE_POSITION', 'top')";
	$t_success &= $this->query($t_query, true);
}

$t_check = $this->query("SELECT * FROM `gm_configuration` WHERE `gm_key` = 'GM_COOKIE_COLOR'", true);
if($t_check->num_rows == 0)
{
	$t_query = "INSERT INTO `gm_configuration` (`gm_key`, `gm_value`) VALUES ('GM_COOKIE_COLOR', '#ffffff')";
	$t_success &= $this->query($t_query, true);
}

$t_check = $this->query("SELECT * FROM `gm_configuration` WHERE `gm_key` = 'GM_COOKIE_TRANSPARENCY'", true);
if($t_check->num_rows == 0)
{
	$t_query = "INSERT INTO `gm_configuration` (`gm_key`, `gm_value`) VALUES ('GM_COOKIE_TRANSPARENCY', '1')";
	$t_success &= $this->query($t_query, true);
}

$t_check = $this->query("SELECT * FROM `gm_configuration` WHERE `gm_key` = 'GM_COOKIE_CLOSE_ICON'", true);
if($t_check->num_rows == 0)
{
	$t_query = "INSERT INTO `gm_configuration` (`gm_key`, `gm_value`) VALUES ('GM_COOKIE_CLOSE_ICON', 'false')";
	$t_success &= $this->query($t_query, true);
}

$t_check = $this->query("SELECT * FROM `gm_configuration` WHERE `gm_key` = 'GM_COOKIE_BUTTON_TEXT_COLOR'", true);
if($t_check->num_rows == 0)
{
	$t_query = "INSERT INTO `gm_configuration` (`gm_key`, `gm_value`) VALUES ('GM_COOKIE_BUTTON_TEXT_COLOR', '#ffffff')";
	$t_success &= $this->query($t_query, true);
}

$t_check = $this->query("SELECT * FROM `gm_configuration` WHERE `gm_key` = 'GM_COOKIE_BUTTON_COLOR'", true);
if($t_check->num_rows == 0)
{
	$t_query = "INSERT INTO `gm_configuration` (`gm_key`, `gm_value`) VALUES ('GM_COOKIE_BUTTON_COLOR', '#2196F3')";
	$t_success &= $this->query($t_query, true);
}

// settings for max amount of bulk invoices or packing slips pdf.
$t_check = $this->query("SELECT * FROM `gm_configuration` WHERE `gm_key` = 'GM_PDF_MAX_AMOUNT_INVOICES_BULK_PDF'", true);
if($t_check->num_rows == 0)
{
	$t_query = "INSERT INTO `gm_configuration` (`gm_key`, `gm_value`) VALUES ('GM_PDF_MAX_AMOUNT_INVOICES_BULK_PDF', '100')";
	$t_success &= $this->query($t_query, true);
}
$t_check = $this->query("SELECT * FROM `gm_configuration` WHERE `gm_key` = 'GM_PDF_MAX_AMOUNT_PACKING_SLIPS_BULK_PDF'", true);
if($t_check->num_rows == 0)
{
	$t_query = "INSERT INTO `gm_configuration` (`gm_key`, `gm_value`) VALUES ('GM_PDF_MAX_AMOUNT_PACKING_SLIPS_BULK_PDF', '100')";
	$t_success &= $this->query($t_query, true);
}

// Configuration values for payment method aliases
// =================================================

$paymentModuleNames = array(
	'AMAZONADVPAY'                 => 'AMAZ',
	'BILLSAFE_3_INSTALLMENT'       => 'BSRA',
	'BILLSAFE_3_INVOICE'           => 'BSRE',
	'CASH'                         => 'BAR',
	'EUSTANDARDTRANSFER'           => 'EUS',
	'BANKTRANSFER'                 => 'LS',
	'SEPA'                         => 'SEPA',
	'COD'                          => 'NN',
	'INVOICE'                      => 'RECH',
	'MONEYORDER'                   => 'VK',
	'PAYPAL3'                      => 'PP',
	'HPCC'                         => 'HPCC',
	'HPDC'                         => 'HPDC',
	'HPDD'                         => 'HPDD',
	'HPGP'                         => 'HPGP',
	'HPIDL'                        => 'HPID',
	'HPPP'                         => 'HPVK',
	'HPPAY'                        => 'HPPP',
	'HPSU'                         => 'HPSU',
	'HPBS'                         => 'HPBS',
	'HPIV'                         => 'HPIV',
	'HPPF'                         => 'HPPF',
	'HPMK'                         => 'HPMK',
	'KLARNA_INVOICE'               => 'KLRE',
	'KLARNA_PARTPAY'               => 'KLRA',
	'IPAYMENT_CC'                  => 'IPCC',
	'IPAYMENT_ELV'                 => 'IPEL',
	'MASTERPAYMENT_ANZAHLUNGSKAUF' => 'MAAN',
	'MASTERPAYMENT_CONFIG'         => 'MACO',
	'MASTERPAYMENT_CREDIT_CARD'    => 'MACC',
	'MASTERPAYMENT_DEBIT_CARD'     => 'MADC',
	'MASTERPAYMENT_ELV'            => 'MAEL',
	'MASTERPAYMENT_FINANZIERUNG'   => 'MAFI',
	'MASTERPAYMENT_PHONE'          => 'MAPH',
	'MASTERPAYMENT_RATENZAHLUNG'   => 'MARA',
	'MASTERPAYMENT_RECHNUNGSKAUF'  => 'MARE',
	'MASTERPAYMENT_SOFORTBANKING'  => 'MASO',
	'SHOPGATE'                     => 'SHG',
	'SKRILL_CC'                    => 'SKCC',
	'SKRILL_CGB'                   => 'SKCB',
	'SKRILL_CSI'                   => 'SKCS',
	'SKRILL_ELV'                   => 'SKEL',
	'SKRILL_GIROPAY'               => 'SKGP',
	'SKRILL_IDEAL'                 => 'SKID',
	'SKRILL_MAE'                   => 'SKMA',
	'SKRILL_NETPAY'                => 'SKNE',
	'SKRILL_PSP'                   => 'SKPP',
	'SKRILL_PWY'                   => 'SKPR',
	'SKRILL_SFT'                   => 'SKSU',
	'SKRILL_WLT'                   => 'SKEW',
	'SKRILL_PAYINV'                => 'SKRE',
	'SKRILL_PAYINS'                => 'SKRA',
	'PAYONE_CC'                    => 'PACC',
	'PAYONE_ELV'                   => 'PAEL',
	'PAYONE_COD'                   => 'PANN',
	'PAYONE_OTRANS'                => 'PAUW',
	'PAYONE_WLT'                   => 'PAPP',
	'PAYONE_INSTALLMENT'           => 'PARA',
	'PAYONE_INVOICE'               => 'PARE',
	'PAYONE_PREPAY'                => 'PAVK',
	'PAYGATE_SSL'                  => 'PAYG',
	'POSTFINANCEAG_BASIC'          => 'POFI',
	'POSTFINANCE_EPAYMENT'         => 'POEP',
	'POSTFINANCEAG_DINERS'         => 'PODI',
	'POSTFINANCEAG_MASTERCARD'     => 'POMA',
	'POSTFINANCEAG_AMEX'           => 'POAM',
	'POSTFINANCEAG_VISA'           => 'POVI',
	'RSMARTSEPA'                   => 'RSMA',
	'SAFERPAYGW'                   => 'SAPA',
	'SOFORT_SOFORTUEBERWEISUNG'    => 'SÜ'
);

/**
 * Add configuration default values for payment module aliases
 */

foreach($paymentModuleNames as $key => $moduleName) 
{
	$t_check = $this->query("SELECT * FROM `configuration` WHERE `configuration_key` = 'MODULE_PAYMENT_" . $key . "_ALIAS'", true);
	if($t_check->num_rows == 0)
	{
		$t_query = "INSERT INTO 
					`configuration` 
				SET 
					`configuration_key` = 'MODULE_PAYMENT_" . $key . "_ALIAS', 
					`configuration_value` = '" . $moduleName . "'";
		$t_success &= $this->query($t_query, true);
	}
}

// Configuration values for shipping method aliases
// =================================================

$shippingModuleNames = array(
	'GAMBIOULTRA' => 'ARTV',
	'CHRONOPOST'  => 'CHRO',
	'DP'          => 'DPD',
	'DHL'         => 'DHLA',
	'DPD'         => 'DPD',
	'FEDEXEU'     => 'FED',
	'HERMESPROPS' => 'HERM',
	'INTERKURIER' => 'INT',
	'AP'          => 'ATP',
	'FLAT'        => 'PAU',
	'CHP'         => 'CHP',
	'SELFPICKUP'  => 'ABH',
	'UPSE'        => 'UPSE',
	'UPS'         => 'UPS',
	'ZONES'       => 'UNV',
	'TABLE'       => 'VKPG',
	'ITEM'        => 'VKST',
	'FREEAMOUNT'  => 'FREI',
	'ZONESE'      => 'VERS'
);

/**
 * Add configuration default values for shipping module aliases
 */

foreach($shippingModuleNames as $key => $moduleName)
{
	$t_check = $this->query("SELECT * FROM `configuration` WHERE `configuration_key` = 'MODULE_SHIPPING_" . $key . "_ALIAS'", true);
	if($t_check->num_rows == 0)
	{
		$t_query = "INSERT INTO 
					`configuration` 
				SET 
					`configuration_key` = 'MODULE_SHIPPING_" . $key . "_ALIAS', 
					`configuration_value` = '" . $moduleName . "'";
		$t_success &= $this->query($t_query, true);
	}
}

$deactivateMLQuery = 'UPDATE gm_configuration SET gm_value = "0" WHERE gm_key = "MODULE_CENTER_MAGNALISTER_INSTALLED"';
$t_check = $this->query('SHOW TABLES LIKE "magnalister_config"', true);
if($t_check->num_rows > 0)
{
	$t_check = $this->query('SELECT value FROM magnalister_config WHERE mkey = "general.passphrase"');
	
	if(count($t_check) === 0 || $t_check[0]['value'] === '')
	{
		$t_success &= is_numeric($this->query($deactivateMLQuery));
	}
	else
	{
		$columnsQuery = $this->query('DESCRIBE `admin_access` "magnalister"', true);
		if($columnsQuery->num_rows === 0)
		{
			$this->query('ALTER TABLE `admin_access` ADD `magnalister` INT(1) NOT NULL DEFAULT "0"');
			$this->query('UPDATE `admin_access`
							SET `magnalister` = 1
							WHERE customers_id = 1
							OR customers_id IN (
								SELECT customers_id
								FROM customers
								WHERE customers_status = 0)');
		}
	}
}
else
{
	$t_success &= is_numeric($this->query($deactivateMLQuery));
}

$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "GM_SEO_BOOST_SHORT_URLS"', true);
if($check->num_rows == 0)
{
	$query = 'INSERT INTO `gm_configuration`
					  SET `gm_key` = "GM_SEO_BOOST_SHORT_URLS", `gm_value` = "false"';
	$t_success &= $this->query($query, true);
}

$check = $this->query('SELECT * FROM `countries` WHERE `countries_iso_code_2` = "ME"', true);
if($check->num_rows == 0)
{
	$query = 'INSERT INTO `countries`
					  SET `countries_name` = "Montenegro", `countries_iso_code_2` = "ME",
					  	  `countries_iso_code_3` = "MNE", `address_format_id` = 1, `status` = 0';
	$t_success &= $this->query($query, true);
}

$result = $this->query('SELECT `countries_id` FROM `countries` WHERE `countries_iso_code_2` = "ME"');
$montenegroCountryId = $result[0]['countries_id'];
if($montenegroCountryId)
{
	$query = 'INSERT INTO `zones_to_geo_zones`
					 SET `zone_country_id` = ' . (int)$montenegroCountryId . ',
					 	 `geo_zone_id` = 5,
					 	 `last_modified` = "' . date('Y-m-d H:i:s') . '",
					 	 `date_added` =  "' . date('Y-m-d H:i:s') . '"';
	
	$t_success &= $this->query($query, true);
}

$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "MODULE_CENTER_POSTFINDER_INSTALLED"', true);
if($check->num_rows > 0)
{
	$query = 'DELETE FROM `gm_configuration` WHERE `gm_key` = "INTRASHIP_USE_POSTFINDER"';
	$t_success &= is_numeric($this->query($query));
}
else
{
	$query = 'UPDATE `gm_configuration` 
				SET `gm_key` = "MODULE_CENTER_POSTFINDER_INSTALLED" 
				WHERE `gm_key` = "INTRASHIP_USE_POSTFINDER"';
	$t_success &= is_numeric($this->query($query));
}